﻿# -*- coding: utf-8 -*-

import copy

#シンプル稜線の丸めとベベル
#初期設定ボタンが動作しないバグを修正
#上位パートに変換がかかっていると使用できないように変更（2010.03.03）
#辺の選択を拡張した後に隣接面に5頂点以上で構成される面があった場合にねじれるバグを修正（2010.11.28)
#shade12で処理が遅いのに対応（2010.12.28）

#ポリゴンメッシュの辺編集モードで辺を一つだけ選択
#このスクリプトを実行するとエッジのループ選択処理が行われ、ループ状（開始点と終了点がつながってる）に
#選択できなかった場合はダイアログが開きます
#(ループ状に選択できた場合はスクリプトは実行できません）
#「分割数」と「幅」を入力して「ok」を押すと、稜線の丸めが行われます
#分割数を1にするとベベルとなります

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っており、辺編集モードで一つの辺だけ選択してる事


def return_henlist2(face):
  #面番号から面を構成する辺の番号を返す
  #前後にsetup_winged_edgeとclean_winged_edgeが必要

  tempvlist=xshade.scene().active_shape().face(face).vertex_indices

  henlist=[]
  for i in tempvlist:
    tempf=xshade.scene().active_shape().eccwfv(face,i,False)
    henlist.append(tempf)

  return henlist




def return_pointlist(pointnum):
  #その点と接続されている頂点の頂点番号をリストで返す（引数　頂点番号）
  pointlist=[]
  totaledgesuu=xshade.scene().active_shape().number_of_edges
  for i in range(totaledgesuu):
    if xshade.scene().active_shape().edge(i).v0==pointnum:
      pointlist.append(xshade.scene().active_shape().edge(i).v1)
    if xshade.scene().active_shape().edge(i).v1==pointnum:
      pointlist.append(xshade.scene().active_shape().edge(i).v0)

  return pointlist

def return_menlist(edgenumber):
  #その辺を共有する面の面番号をリストで返す（引数　辺番号）
  menlist=[]
  edgevertex=[xshade.scene().active_shape().edge(edgenumber).v0,xshade.scene().active_shape().edge(edgenumber).v1]
  totalmenmen=xshade.scene().active_shape().number_of_faces
  for i in range(totalmenmen):
    konomen=0
    temppoint=list(xshade.scene().active_shape().face(i).vertex_indices)
    for j in temppoint:
      if edgevertex[0]==j:
        konomen+=1
      if edgevertex[1]==j:
        konomen+=1
    if konomen==2:
      menlist.append(i)

  return menlist

def erase_same_num(list1):
  #リスト内に同じ値が重複する場合は一つに減らす関数 例[1,1,1,3,3,4]→[1,3,4]
  #呼び出す時はlist=erase_same_num(list)ではなく、erase_same_num(list)で良い
  list1.sort()
  nagasa=len(list1)
  if nagasa>1:
    kesu=[]
    for i in range(nagasa-1):
      if list1[i]==list1[i+1]:
        kesu.append(list1[i])
    kesukaisuu=len(kesu)
    if kesukaisuu>0:
      for i in kesu:
        list1.remove(i)



def erase_only_same_num(list1,list2):
  #list1の値の中にlist2の値と同じものがあった場合は、それだけ削除する関数 例リスト1[1,2,3] リスト2[2,3]→リスト1[1]
  kesulist=[]
  for i in list1:
    for j in list2:
      if i==j:
       kesulist.append(i)
  for i in kesulist:
    list1.remove(i)

def return_edge_number(pointnum1,pointnum2):
  #頂点二つの頂点番号を与えると、その頂点で構成される辺の辺番号を返す
  #エラー（辺の両端のポイントでは無い）の場合は-1を返す
  returnnum=-1
  for i in range(xshade.scene().active_shape().number_of_edges):
    if xshade.scene().active_shape().edge(i).v0==pointnum1 and xshade.scene().active_shape().edge(i).v1==pointnum2:
      returnnum=i
      break

    if xshade.scene().active_shape().edge(i).v1==pointnum1 and xshade.scene().active_shape().edge(i).v0==pointnum2:
      returnnum=i
      break

  return returnnum


xscene=xshade.scene()
ashape=xshade.scene().active_shape()

dousasuru=0

if xshade.scene().is_modify_mode==True and xshade.scene().active_shape().type==7:
  if xshade.scene().selection_mode==1:
    activeedgelist=[]
    for i in range(xshade.scene().active_shape().number_of_edges):
      if xshade.scene().active_shape().edge(i).active==True:
        activeedgelist.append(i)
    if len(activeedgelist)==1:
      if len(return_menlist(activeedgelist[0]))==2:
        dousasuru=1

if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')



if dousasuru==1:
  #ループしてないかチェック
  tuikalist=[]
  startpoint=xshade.scene().active_shape().edge(activeedgelist[0]).v0
  startpoint2=xshade.scene().active_shape().edge(activeedgelist[0]).v1
  startedge=activeedgelist[0]
#  endpoint=xshade.scene().active_shape().edge(activeedgelist[1]).v1
  loop=1
  imapoint=startpoint
  imaedge=startedge
  looppointlist=[]
  looppointlist.append(imapoint)

  while(loop==1):
    setuzokupointlist=return_pointlist(imapoint)
    if len(setuzokupointlist)!=4:
      break
    else:
      rinsetumenlist=return_menlist(imaedge)
      tempvlist=[]
      tempvlist+=xshade.scene().active_shape().face(rinsetumenlist[0]).vertex_indices
      tempvlist+=xshade.scene().active_shape().face(rinsetumenlist[1]).vertex_indices
      erase_same_num(tempvlist)
      erase_only_same_num(setuzokupointlist,tempvlist)
      if setuzokupointlist[0]==startpoint:
        dousasuru=0
        loop=0
      else:
        looppointlist.append(setuzokupointlist[0])
        imaedge=return_edge_number(imapoint,setuzokupointlist[0])
        imapoint=setuzokupointlist[0]

  if dousasuru==0:
    loop=0
  else:
    loop=1

  #looppointlistの反転

  templist=copy.copy(looppointlist)
  for i in range(len(looppointlist)):
    looppointlist[i]=templist[len(looppointlist)-i-1]

  imapoint=startpoint2
  imaedge=startedge
  looppointlist.append(imapoint)

  while(loop==1):
    setuzokupointlist=return_pointlist(imapoint)
    if len(setuzokupointlist)!=4:
      break
    else:
      rinsetumenlist=return_menlist(imaedge)
      tempvlist=[]
      tempvlist+=xshade.scene().active_shape().face(rinsetumenlist[0]).vertex_indices
      tempvlist+=xshade.scene().active_shape().face(rinsetumenlist[1]).vertex_indices
      erase_same_num(tempvlist)
      erase_only_same_num(setuzokupointlist,tempvlist)
      looppointlist.append(setuzokupointlist[0])
      imaedge=return_edge_number(imapoint,setuzokupointlist[0])
      imapoint=setuzokupointlist[0]


#if dousasuru==1:
#  if len(looppointlist)<=3 and len(return_pointlist(looppointlist[0]))>=5 and len(return_pointlist(looppointlist[len(looppointlist)-1]))>=5:dousasuru=0

if dousasuru==1:
  mai=0
  if len(return_pointlist(looppointlist[0]))>=5:mai+=1
  if len(return_pointlist(looppointlist[len(looppointlist)-1]))>=5:mai+=1
  if (len(looppointlist)-mai)<=1:dousasuru=0


if dousasuru==1:


  #ループ選択状態にする
  xshade.scene().selection_mode=2
  for i in looppointlist:
    xshade.scene().active_shape().vertex(i).active=True
  xshade.scene().selection_mode=1

  #初期設定
  renzoku=1
  haba=100
  bunkatu=5
  dfhaba=haba
  dfbunkatu=bunkatu

  #隣接面リストを作成
  eflist=[]
  for i in range(ashape.number_of_edges):
    eflist.append([])


  ashape.adjust_face_direction()
  ashape.setup_winged_edge()
  for i in range(ashape.number_of_faces):
    thenlist=return_henlist2(i)
    for gg in thenlist:
      eflist[gg].append(i)


  ashape.clean_winged_edge()



  while(renzoku==1):
    #ダイアログ開く
    dialog=xshade.create_dialog_with_uuid('0x51900F38')
    dialog.append_default_button()
    idx1=dialog.append_int('分割数（1以上）')
    idx2=dialog.append_float('幅（0より大）')
    dialog.set_default_value(idx1,dfbunkatu)
    dialog.set_default_value(idx2,dfhaba)
    kekka=dialog.ask('稜線の丸めとベベル')

    if kekka==False:
      renzoku=0
      #辺の選択状態を元に戻す
      for i in range(xshade.scene().active_shape().number_of_edges):
        xshade.scene().active_shape().edge(i).active=False
      xshade.scene().active_shape().edge(startedge).active=True
      xshade.scene().exit_modify_mode()
      xshade.scene().enter_modify_mode()


    if kekka==True:
      xshade.scene().inhibit_update()

      bunkatu=dialog.get_value(idx1)
      if bunkatu<1:bunkatu=1
      haba=dialog.get_value(idx2)
      if haba<=0:haba=0.1

      #元の形状をクリップボードにコピーしておく
      xshade.scene().copy()
      xshade.scene().enter_modify_mode()

      #端点a（開始点）とb（終了点）に接続されている辺の数を調査
      motolooppointlist=copy.copy(looppointlist)
      anum=len(return_pointlist(looppointlist[0]))
      bnum=len(return_pointlist(looppointlist[len(looppointlist)-1]))
      tempb=looppointlist[len(looppointlist)-1]
      if anum>=4:looppointlist.remove(looppointlist[0])
      if bnum>=4:looppointlist.remove(tempb)
#      if len(looppointlist)==1:
#        looppointlist.append(looppointlist[0])

      #三本のループリストを作成
      l1list=[]
      l2list=[]
      l3list=[]
      for i in looppointlist:
        l2list.append(i)

      tempsetulist=[]
      for i in looppointlist:
        tempc=return_pointlist(i)
        erase_only_same_num(tempc,motolooppointlist)
        tempsetulist.append(tempc)

#        tempsetulist.append(return_pointlist(i))

#      print tempsetulist
      for i in range(len(looppointlist)):
        if i==0:
          l1list.append(tempsetulist[0][0])
          l3list.append(tempsetulist[0][1])
          maeedge=return_edge_number(looppointlist[i],tempsetulist[0][0])


        #ここのアルゴリズムを隣接面で検査する方式に変更

#        else:
#          if return_edge_number(l1list[i-1],tempsetulist[i][0])!=-1 or l1list[i-1]==tempsetulist[i][0]:
#            l1list.append(tempsetulist[i][0])
#            l3list.append(tempsetulist[i][1])
#          else:
#            l1list.append(tempsetulist[i][1])
#            l3list.append(tempsetulist[i][0])

        else:
          #隣接面で検査する新アルゴリズム
          tugiedge=return_edge_number(looppointlist[i],tempsetulist[i][0])
          #maeedgeと同じ隣接面を持ってるか?
          hanteie=0
          for vvv in eflist[maeedge]:
            for hhh in eflist[tugiedge]:
              if vvv==hhh:hanteie+=1

          if tugiedge!=-1 and hanteie>0:
            l1list.append(tempsetulist[i][0])
            l3list.append(tempsetulist[i][1])
            maeedge=tugiedge
          else:
            l1list.append(tempsetulist[i][1])
            l3list.append(tempsetulist[i][0])
            maeedge=return_edge_number(looppointlist[i],tempsetulist[i][1])





      l1poslist=[]
      l2poslist=[]
      l3poslist=[]
      for i in range(len(l1list)):
        l1poslist.append(xshade.scene().active_shape().vertex(l1list[i]).position)
        l2poslist.append(xshade.scene().active_shape().vertex(l2list[i]).position)
        l3poslist.append(xshade.scene().active_shape().vertex(l3list[i]).position)

      #三本のリストから自由曲面を作成
      xshade.scene().begin_creating()
      xshade.scene().begin_surface_part()
      xshade.scene().end_surface_part()
      xshade.scene().end_creating()


      xshade.scene().begin_creating()
      xshade.scene().begin_line(None,False)
      for i in range(len(l1list)):
        xshade.scene().append_point(l1poslist[i], None, None, None, None)
      xshade.scene().end_line()

      xshade.scene().begin_line(None,False)
      for i in range(len(l2list)):
        xshade.scene().append_point(l2poslist[i], None, None, None, None)
      xshade.scene().end_line()

      xshade.scene().begin_line(None,False)
      for i in range(len(l3list)):
        xshade.scene().append_point(l3poslist[i], None, None, None, None)
      xshade.scene().end_line()

      xshade.scene().end_creating()

      #角の丸め
      xshade.scene().exit_modify_mode()
      xshade.scene().select_sister()
      xshade.scene().round_edge(haba)

      xshade.scene().select_sister()
      xshade.scene().clear()
      xshade.scene().select_brother(2)
      xshade.scene().clear()
      xshade.scene().select_parent()
      xshade.scene().active_shape().convert_to_polygon_mesh_with_divisions(bunkatu,len(l1list)-1)

      l1tuilist=[]
      l3tuilist=[]
      for i in range(len(l1list)):
        l1tuilist.append(i)
      for i in range(len(l1list)):
        tempp=xshade.scene().active_shape().total_number_of_control_points-len(l1list)
        l3tuilist.append(tempp+i)


      #ポリゴンメッシュの頂点座標リストとエッジの両端の頂点番号リストを作成
      vposlist=[]
      v01list=[]

      for i in range(xshade.scene().active_shape().total_number_of_control_points):
        vposlist.append(xshade.scene().active_shape().vertex(i).position)

      for i in range(xshade.scene().active_shape().number_of_edges):
        v01list.append([xshade.scene().active_shape().edge(i).v0,xshade.scene().active_shape().edge(i).v1])

      xshade.scene().clear()

      #上のポリゴンメッシュに追加する
      tasu=xshade.scene().active_shape().total_number_of_control_points
      for i in vposlist:
        xshade.scene().active_shape().append_point(i)

      #元の点を消す（ただし頂点番号は変化させない）
      xshade.scene().active_shape().begin_removing_control_points()
      for i in l2list:
        xshade.scene().active_shape().vertex(i).remove()

      for i in v01list:
        xshade.scene().active_shape().append_edge(i[0]+tasu,i[1]+tasu)

      #l1やL3と対のポイントを結ぶ
      for i in range(len(l1list)):
        xshade.scene().active_shape().append_edge(l1list[i],l1tuilist[i]+tasu)
        xshade.scene().active_shape().append_edge(l3list[i],l3tuilist[i]+tasu)

      #5点以上で止まった場合はそこも結ぶ
      if anum>=4:
        motop=motolooppointlist[0]
        musubulist=[]
        for gg in range(bunkatu+1):
          musubulist.append(len(looppointlist)*gg)
        for i in musubulist:
          xshade.scene().active_shape().append_edge(motop,i+tasu)

      if bnum>=4:
        motop=motolooppointlist[len(motolooppointlist)-1]
        musubulist=[]
        for gg in range(bunkatu+1):
          musubulist.append(len(looppointlist)*gg+len(looppointlist)-1)
        for i in musubulist:
          xshade.scene().active_shape().append_edge(motop,i+tasu)


      xshade.scene().active_shape().end_removing_control_points()

      #重複点を整理して向きを統一する
      xshade.scene().active_shape().cleanup_redundant_vertices() 
      xshade.scene().active_shape().adjust_face_direction()

      #やり直す？
      xshade.scene().enter_modify_mode()
      xshade.scene().allow_update()
      dialog=xshade.create_dialog()
      idx333=dialog.append_push_button('結果を確定する場合はokを')
      idx444=dialog.append_push_button('取り消す場合はcancelを押してください')
      kekka2=dialog.ask('稜線の角の丸めとベベル')

      if kekka2==False:
        idou1=0
        if xshade.scene().active_shape().has_sis==True:
          idou1=1
        xshade.scene().paste()
        xshade.scene().select_sister(1)
        xshade.scene().clear()
        if idou1==1:
          xshade.scene().select_brother()
        xshade.scene().enter_modify_mode()
        xshade.scene().selection_mode=2
        for i in looppointlist:
          xshade.scene().active_shape().vertex(i).active=True
        xshade.scene().selection_mode=1
        looppointlist=copy.copy(motolooppointlist)
        ashape=xshade.scene().active_shape()

      if kekka2==True:
        renzoku=0
#        xshade.scene().enter_modify_mode()

      #戻す終わり










